// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from data_tamer_msgs:msg/Snapshot.idl
// generated code does not contain a copyright notice

#ifndef DATA_TAMER_MSGS__MSG__DETAIL__SNAPSHOT__STRUCT_HPP_
#define DATA_TAMER_MSGS__MSG__DETAIL__SNAPSHOT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__data_tamer_msgs__msg__Snapshot __attribute__((deprecated))
#else
# define DEPRECATED__data_tamer_msgs__msg__Snapshot __declspec(deprecated)
#endif

namespace data_tamer_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Snapshot_
{
  using Type = Snapshot_<ContainerAllocator>;

  explicit Snapshot_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp_nsec = 0ull;
      this->schema_hash = 0ull;
    }
  }

  explicit Snapshot_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp_nsec = 0ull;
      this->schema_hash = 0ull;
    }
  }

  // field types and members
  using _timestamp_nsec_type =
    uint64_t;
  _timestamp_nsec_type timestamp_nsec;
  using _schema_hash_type =
    uint64_t;
  _schema_hash_type schema_hash;
  using _active_mask_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _active_mask_type active_mask;
  using _payload_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _payload_type payload;

  // setters for named parameter idiom
  Type & set__timestamp_nsec(
    const uint64_t & _arg)
  {
    this->timestamp_nsec = _arg;
    return *this;
  }
  Type & set__schema_hash(
    const uint64_t & _arg)
  {
    this->schema_hash = _arg;
    return *this;
  }
  Type & set__active_mask(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->active_mask = _arg;
    return *this;
  }
  Type & set__payload(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->payload = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    data_tamer_msgs::msg::Snapshot_<ContainerAllocator> *;
  using ConstRawPtr =
    const data_tamer_msgs::msg::Snapshot_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      data_tamer_msgs::msg::Snapshot_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      data_tamer_msgs::msg::Snapshot_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__data_tamer_msgs__msg__Snapshot
    std::shared_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__data_tamer_msgs__msg__Snapshot
    std::shared_ptr<data_tamer_msgs::msg::Snapshot_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Snapshot_ & other) const
  {
    if (this->timestamp_nsec != other.timestamp_nsec) {
      return false;
    }
    if (this->schema_hash != other.schema_hash) {
      return false;
    }
    if (this->active_mask != other.active_mask) {
      return false;
    }
    if (this->payload != other.payload) {
      return false;
    }
    return true;
  }
  bool operator!=(const Snapshot_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Snapshot_

// alias to use template instance with default allocator
using Snapshot =
  data_tamer_msgs::msg::Snapshot_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace data_tamer_msgs

#endif  // DATA_TAMER_MSGS__MSG__DETAIL__SNAPSHOT__STRUCT_HPP_
